#include <dpmi.h>
#include <math.h>
#define OBJNUM 4

__dpmi_regs regs;
char p[64000]; /* Buffer de pantalla */
int N, K, OBJMIN, OBJMIN2, OBJ[OBJNUM], L, POS, POS2, S, t[8200], XX, YY, XQ, YQ, t2[8200], IPOS;
float X0, Y0, Z0, X1, Y1, Z1, D, MD, NX, NY, NZ, CA, X, Y, COL, COL2,
      A1, B1, C1, A2, B2, C2, MV, MV2, M, M2, XX1, YY1, TC,
      A[OBJNUM], B[OBJNUM], C[OBJNUM], R[OBJNUM],
      A0, B0, C0, TN, TMIN,
      RZ, TB, T[OBJNUM];

int main()
{
    memset(&regs, 0, sizeof regs);   /* Modo de video 13h */
    regs.x.ax=0x13;
    __dpmi_int(0x10, &regs);

    outportb (0x3c8, 0);   /* Cambiar la paleta a tonos de grises */
    for (N=0; N<=127; N++)
    {
        outportb (0x3c9, 0);
        outportb (0x3c9, (int)N/4);
        outportb (0x3c9, (int)N/2);
    }
    for (N=0; N<=127; N++)
    {
        outportb (0x3c9, (int)N/2);
        outportb (0x3c9, (int)31+N/4);
        outportb (0x3c9, 63);
    }
    D=230;
    for (L=0;L<=199;L++)
    {
    OBJ[0]=0; A[0]=-50+L; B[0]=0; C[0]=-100; R[0]=-55*55;
    OBJ[1]=0; A[1]=50-L; B[1]=-25; C[1]=-120; R[1]=-55*55;
    OBJ[2]=0; A[2]=0; B[2]=500; C[2]=-220; R[2]=-500*500;
    OBJ[3]=1; A[3]=60; B[3]=-35; C[3]=-30;
    POS=400;
    for (N=0;N<=3999;N++)
    {
       t2[N]=0;
    }
    for (Y=-40;Y<=39;Y+=2)
    {
        for (X=-80;X<=79;X+=2)
        {
            X0=X;
            Y0=Y;
            Z0=0;
            MD=sqrt(X0*X0+Y0*Y0+D*D);
            X1=X0/MD;
            Y1=Y0/MD;
            Z1=-(D+Z0)/MD;
            K=0;
            COL=0;
            OBJMIN=OBJNUM;
            t2[POS]=OBJNUM;
            do
            {
                TMIN=327680;
                for (N=0; N<=2; N++)
                {
                    if (OBJ[N]==0 && OBJ[N]!=OBJMIN)
                    {
                         A0=A[N]-X0;
                         B0=B[N]-Y0;
                         C0=C[N]-Z0;
                         TB=A0*X1+B0*Y1+C0*Z1;
                         RZ=TB*TB-A0*A0-B0*B0-C0*C0;
                         if (RZ>=R[N])
                         {
                              TN=(TB-sqrt(RZ-R[N]));
                              if (TN<TMIN && TN>0)
                              {
                                   TMIN=TN;
                                   OBJMIN2=N;
                              }
                         }
                    }
                }
                OBJMIN=OBJMIN2;
                if (TMIN<327680 && OBJ[OBJMIN]==0)
                {
                     t2[POS]=t2[POS]*K*OBJNUM*3+OBJMIN;
                     X0+=X1*TMIN;
                     Y0+=Y1*TMIN;
                     Z0+=Z1*TMIN;
                     NX=(X0-A[OBJMIN]);
                     NY=(Y0-B[OBJMIN]);
                     NZ=(Z0-C[OBJMIN]);
                     CA=2*(NX*X1+NY*Y1+NZ*Z1)/(NX*NX+NY*NY+NZ*NZ+1);
                     X1-=NX*CA;
                     Y1-=NY*CA;
                     Z1-=NZ*CA;
                     A2=A[3]-X0;
                     B2=B[3]-Y0;
                     C2=C[3]-Z0;
                     MV=sqrt(A2*A2+B2*B2+C2*C2);
                     A2=A2/MV;
                     B2=B2/MV;
                     C2=C2/MV;
                     S=0;
                     for (N=0; N<=2; N++)
                     {
                        if (OBJ[N]==0 && S!=1)
                        {
                           A0=X0-A[N];
                           B0=Y0-B[N];
                           C0=Z0-C[N];
                           TB=A2*A0+B2*B0+C2*C0;
                           RZ=TB*TB-A0*A0-B0*B0-C0*C0;
                           if (RZ>=R[N] && TB<0)
                           {
                           S=1;
                           t2[POS]=t2[POS]<<5;
                           }
                        }
                     }
                     if (!S)
                     {
                     t2[POS]=t2[POS]+1;
                     COL2=(X1*A2+Y1*B2+Z1*C2);
                     if (COL2<0) COL2=0;
                     COL2=(COL2*COL2*COL2*COL2);
                     MV=sqrt(NX*NX+NY*NY+NZ*NZ);
                     if (COL2<0) COL2=0;
                     COL2=COL2+(NX*A2+NY*B2+NZ*C2)/(MV);
                     if (COL2<0) COL2=0;
                     COL+=COL2/((K+1)*(K+1)*2);
                     if (COL>1) COL=1;
                     }
                K++;
                }
            }
            while ((TMIN<327680) && (K <=2));
            if (!K) COL=50; else COL=COL*255;
            t[POS]=COL;
            POS++;
        }
    }
    POS=482;
    POS2=0;
    for (YQ=6;YQ<=43;YQ++)
    {
        for (XQ=2;XQ<=77;XQ++)
        {
             if (t2[POS]==t2[POS+1] && t2[POS]==t2[POS+80] && t2[POS]==t2[POS+81])
             {
                IPOS=(YQ*1280+(XQ<<2));
                for (YY=0;YY<=3;YY++)
                {
                    for (XX=0;XX<=3;XX++)
                    {
                       p[IPOS]=(((t[POS+80]*(4-XX)+t[POS+81]*XX))*(YY)+((t[POS]*(4-XX)+t[POS+1]*XX))*(4-YY))>>4;
                       IPOS++;
                    }
                    IPOS+=316;
                }
             }
             else
             {
    for (YY1=0;YY1<=3;YY1++)
    {
        for (XX1=0;XX1<=3;XX1++)
        {
          if (XX1 || YY1)
          {
            X0=(-160+XQ*4+XX1)/2;
            Y0=(-100+YQ*4+YY1)/2;
            Z0=0;
            MD=sqrt(X0*X0+Y0*Y0+D*D);
            X1=X0/MD;
            Y1=Y0/MD;
            Z1=-(D+Z0)/MD;
            K=0;
            COL=0;
            OBJMIN=OBJNUM;
            do
            {
                TMIN=327680;
                for (N=0; N<=2; N++)
                {
                    if (OBJ[N]==0 && OBJ[N]!=OBJMIN)
                    {
                         A0=A[N]-X0;
                         B0=B[N]-Y0;
                         C0=C[N]-Z0;
                         TB=A0*X1+B0*Y1+C0*Z1;
                         RZ=TB*TB-A0*A0-B0*B0-C0*C0;
                         if (RZ>=R[N])
                         {
                              TN=(TB-sqrt(RZ-R[N]));
                              if (TN<TMIN && TN>0)
                              {
                                   TMIN=TN;
                                   OBJMIN2=N;
                              }
                         }
                    }
                }
                OBJMIN=OBJMIN2;
                if (TMIN<327680 && OBJ[OBJMIN]==0)
                {
                     X0+=X1*TMIN;
                     Y0+=Y1*TMIN;
                     Z0+=Z1*TMIN;
                     NX=(X0-A[OBJMIN]);
                     NY=(Y0-B[OBJMIN]);
                     NZ=(Z0-C[OBJMIN]);
                     CA=2*(NX*X1+NY*Y1+NZ*Z1)/(NX*NX+NY*NY+NZ*NZ+1);
                     X1-=NX*CA;
                     Y1-=NY*CA;
                     Z1-=NZ*CA;
                     A2=A[3]-X0;
                     B2=B[3]-Y0;
                     C2=C[3]-Z0;
                     MV=sqrt(A2*A2+B2*B2+C2*C2);
                     A2=A2/MV;
                     B2=B2/MV;
                     C2=C2/MV;
                     S=0;
                     for (N=0; N<=2; N++)
                     {
                        if (OBJ[N]==0  && S!=1)
                        {
                           A0=X0-A[N];
                           B0=Y0-B[N];
                           C0=Z0-C[N];
                           TB=A2*A0+B2*B0+C2*C0;
                           RZ=TB*TB-A0*A0-B0*B0-C0*C0;
                           if ((RZ>=R[N]) && TB<0) S=1;
                        }
                     }
                     if (!S)
                     {
                     COL2=(X1*A2+Y1*B2+Z1*C2);
                     if (COL2<0) COL2=0;
                     COL2=(COL2*COL2*COL2*COL2);
                     MV=sqrt(NX*NX+NY*NY+NZ*NZ);
                     if (COL2<0) COL2=0;
                     COL2=COL2+(NX*A2+NY*B2+NZ*C2)/(MV);
                     if (COL2<0) COL2=0;
                     COL+=COL2/((K+1)*(K+1)*2);
                     if (COL>1) COL=1;
                     }

                K++;
                }
            }
            while ((TMIN<327680) && (K <=2));
            if (!K) COL=50; else COL=COL*255;
            p[(int)((YY1+YQ*4)*320+XQ*4+XX1)]=COL;
          }
          else p[YQ*1280+XQ*4]=t[POS];
        }
    }
             }
             POS++;
        }
        POS+=4;
    }
    _dosmemputl(p, 14000, 0xa0000);   /* Pasar buffer a pantalla */
    }
}

